        ; LZdemo-0 - Lempel-Ziv pack/unpack demo routine

        org  64500

MAXSIZE:equ  63

IBEG:   defw 34000           ;input start
MAXLEN: defb MAXSIZE         ;maximum match length
MCWORK: defs 37              ;start of working storage

PTMP:   equ  MCWORK          ;00 window match start address (temporary)
PBEG:   equ  MCWORK+2        ;02 window match start address (final)
PLEN:   equ  PBEG+2          ;04 window match length
TMPBYTE:equ  PLEN+1          ;05 temp.store
OBYTES: equ  PLEN+2          ;06 encoded bytes output
CPOS:   equ  OBYTES+2        ;08 coding position
CNXT:   equ  CPOS+2          ;10 lookahead pointer
LEND:   equ  CNXT+2          ;12 encoding end
LPOS:   equ  LEND+2          ;14 encoding step; starts at IEND
WINDIFF:equ  LPOS+2          ;16 (20) (WINZ-PINA+1)-(WWIDTH) flag: 0=equal, else=not equal
PWIDTHF:equ  LPOS+3          ;17 (21) window width (adjusted) flag: 0=zero, else=not zero
WINA:   equ  LPOS+4          ;18 (22) LH window boundary
WINZ:   equ  WINA+2          ;20 (24) RH window boundary
PINA:   equ  WINZ+2          ;22 (26) LH window boundary (adjusted)
DBEG:   equ  PINA+2          ;24 (32) decoded output start; starts at (LEND)+1

TXTPIC: equ  MCWORK+26 ;40       ;*entered: 2=text,0=pict; 1=print,0=don't
ILEN:   equ  MCWORK+27 ;42       ;*entered: input length (256-10000)
IEND:   equ  MCWORK+29 ;44       ;=calculated: input end (IBEG+ILEN)
ILAST:  equ  MCWORK+31 ;46       ;=calculated: input last byte address (IEND-1)
WWIDTH: equ  MCWORK+33 ;48       ;*entered: window width (64-255)
CODSEQ: equ  MCWORK+34 ;52       ;coding flag byte sequence: 8->1
CODADD: equ  MCWORK+35 ;54       ;coding flag byte address

PRINTS: equ  $203c           ;PR-STRING print a string length BC from DE
STAKA:  equ  $2d28           ;to calculator stack: A
STAKBC: equ  $2d2b           ;to calculator stack: BC
FPTOBC: equ  $2da2           ;from calculator stack: BC
FPTOA:  equ  $2dd5           ;from calculator stack: A

;ENCODING
; Coding flag byte specifies length of next 8 entries.
; Coding entries may be:
; 0 matches: 1 byte  : cccccccc           : cchar
; 1 match:   1 byte  : mmmmmmmm           : mchar
;2+ matches: 2 bytes : llllllll oooooooo  : length+offset

        ;ENCODING SETUP
SETUPE: ld   hl,(IBEG)       ;(IBEG)=start of input
        push hl           ;1>
        ld   (CPOS),hl       ;(CPOS)=coding position
        ld   bc,(ILEN)
        add  hl,bc
        ld   (IEND),hl       ;=end of input
        ld   (CODADD),hl     ;(CODADD)=coding flag byte address
        ld   (hl),0
        inc  hl
        ld   (LPOS),hl       ;=start of output
        dec  hl
        dec  hl
        ld   (ILAST),hl
        ld   de,1
        ld   (OBYTES),de     ;(OBYTES) =encoded bytes output
        ld   ix,MCWORK       ;
        ld   (ix+34),8       ;(CODSEQ)=coding flag byte sequence

        pop  hl           ;1<
        ld   bc,(WWIDTH)     ;WWIDTH=window width (one byte)
        ld   b,d             ;D =0
        sbc  hl,bc           ;HL=IBEG-WWIDTH
        ld   (WINA),hl       ;WINA,WINZ=left,right window boundaries
        ld   hl,(IBEG)
        dec  hl
        ld   (WINZ),hl

        exx
        push hl              ;save H'L' (holds calculator RET address)

        xor  a
        ld   (PLEN),a
        ld   (PWIDTHF),a

        ;START OF THE ENCODING LOOP
ENLOOP: ld   hl,(WINA)       ;#3
        ld   de,(IBEG)
        xor  a
        ld   bc,(WINA)
        sbc  hl,de
        jr   nc,LET_PA       ;IF WINA>=IBEG
        ld   bc,(IBEG)       ;IF WINA< IBEG (window not fully open)
        dec  a

LET_PA: ld   (PINA),bc       ;PINA=adjusted LH window boundary
        ld   (WINDIFF),a
        ld   hl,(WINZ)
        and  a
        sbc  hl,bc
        inc  hl
        ld   b,h
        ld   c,l             ;BC=adjusted window width

        ;loop return point if window is fully open
        ;BC holds CPDR counter
ENLOOPZ:ld   hl,(CPOS)
        ld   de,(IEND)
        and  a
        sbc  hl,de
        jp   nc,EOINPUT       ;end of input

        ld   de,(CPOS)
        ld   (CNXT),de       ;lookahead pointer
        ld   de,0
        ld   (PBEG),de
        xor  a
        ld   (PLEN),a        ;PBEG,PLEN = matched start,length in window
        ld   hl,(WINZ)

        ld   a,(PWIDTHF)
        or   a
        jr   nz,FIND12
        inc  a               ;only done once
        ld   (PWIDTHF),a
        jr   LONGEST

FIND12:

        ;will search from the history match point, if found,
        ;otherwise from the RH window edge (WINZ), backwards
PA2PZ:  ld   de,(CPOS)
        ld   a,(de)          ;A =character at Coding Position
        cpdr                 ;search backwards for a match
        jp   z,MASTART
        ;no further matches in window; output the last longest match (if any)
        ;(PBEG) & (PLEN) will identify the last longest match found
LONGEST:;call OUTPUT

;******
        ;output subroutine
OUTPUT: ld   hl,(LPOS)
        ld   a,(PLEN)
        cp   1
        jr   z,MATCH1        ;IF PLEN=1
        jr   c,MATCH0        ;IF PLEN=0

;2+ matches: 2 bytes : llllllll oooooooo  : length+offset
MATCH2: ld   (hl),a          ;=(PLEN)
        inc  hl
        exx
        ld   hl,(CNXT)
        ld   bc,(PBEG)
        sbc  hl,bc
        ld   bc,(PLEN)       ;deduct (CNXT-CPOS);
        ld   b,0
        sbc  hl,bc           ;HL=lookback offset
        ld   a,l
        exx
        ld   (hl),a          ;=offset
        ld   c,2             ;C =byte copy counter
        dec  (ix+04)         ;=(PLEN)
        jr   OUTEND2

; 1 match:   1 byte  : mmmmmmmm           : mchar
MATCH1: ld   de,(PBEG)
        dec  (ix+04)         ;=(PLEN)
        jr   MATCHA

; 0 matches: 1 byte  : cccccccc           : cchar
MATCH0: ld   de,(CNXT)
MATCHA: ld   a,1             ;A =byte copy counter

OUTEND: ld   c,a
        ld   a,(de)
        ld   (hl),a
OUTEND2:ld   d,0
        ld   e,c
        ld   a,c

        exx
        ld   hl,(CODADD)     ;(CODADD)=coding flag byte address
        ld   c,(hl)
        sla  c
        dec  a
        add  a,c
        ld   (hl),a
        exx
        dec  (ix+34)         ;(CODSEQ)=coding flag byte sequence
        jr   nz,OUTADD

        inc  hl
        ld   (CODADD),hl     ;(CODADD)=coding flag byte address
        ld   (hl),d          ;D =0
        ld   (ix+34),8       ;(CODSEQ)=coding flag byte sequence
        inc  e

OUTADD:;call OUTUPD
OUTUPD: ld   hl,(OBYTES)
        add  hl,de           ;add DE bytes
        ld   (OBYTES),hl
        ld   hl,(LPOS)
        add  hl,de           ;add DE bytes
        ld   (LPOS),hl

        ld   de,(PLEN)       ;update pointers by PLEN+1
        ld   d,0
        inc  de
        ld   hl,(WINA)
        add  hl,de
        ld   (WINA),hl
        ld   hl,(PINA)
        add  hl,de
        ld   (PINA),hl
        ld   hl,(WINZ)
        add  hl,de
        ld   (WINZ),hl
        ld   hl,(CPOS)
        add  hl,de
        ld   (CPOS),hl
;******

        ld   a,(WINDIFF)
        or   a               ;window fully open?
        jp   nz,ENLOOP       ;no
        ld   bc,(WWIDTH)
        ld   b,a             ;A =0
        jp   ENLOOPZ

MASTART:push hl           ;1>;preserve match start registers
        exx               ;H'L' was saved prior to entering ENLOOP
        pop  hl           ;1<
        inc  hl
        ld   b,0             ;match length
        ld   de,(CPOS)
        ld   (PTMP),hl       ;match start

        ;determine the extent of the match
MALOOP: ld   a,(ILAST)
        cp   e
        jr   nz,MANEXT1
        ld   a,(ILAST+1)
        cp   d
        jr   z,NEXTSW        ;reached end of input

MANEXT1:ld   a,(CPOS)
        cp   l
        jr   nz,MANEXT2
        ld   a,(CPOS+1)
        cp   h
        jr   z,NEXTSW        ;reached Coding Position

MANEXT2:ld   a,(de)          ;compare lookahead character
        cp   (hl)            ;   with window character
        jr   nz,NEXTSW       ;no further match

        inc  b
        inc  hl              ;window pointer
        inc  de              ;lookahead pointer
        ld   a,b             ;A =new match length
        cp   (ix-01)         ;(MAXLEN)
        jr   nz,MALOOP

NEXTSW: ld   a,(PLEN)        ;A =longest match length so far
        cp   b
        ld   a,b             ;A =new match length
        jr   nc,NOTLONG

        ld   (CNXT),de
        ld   hl,(PTMP)
        ld   (PBEG),hl
        ld   (PLEN),a

NOTLONG:exx
        cp   (ix-01)         ;(MAXLEN)
        jp   nc,LONGEST
        ld   a,b
        or   c
        jp   nz,PA2PZ
        jp   LONGEST

EOINPUT:;ld   de,$ffff
        ;ld   a,(ix+34)
        ;cp   8               ;if there's an empty trailing flag byte,
        ;call z,OUTUPD        ; deduct 1 from the byte counters
        ld   hl,(CODADD)     ;(CODADD)=coding flag byte address
        ld   a,(hl)
        or   a
        jr   z,SETUPD
EOINSLA:sla  a               ;left justify the final coding byte
        dec  (ix+34)         ;(CODSEQ)=coding flag byte sequence
        jr   nz,EOINSLA
        ld   (hl),a

        ;DECODING SETUP
SETUPD: ld   de,(LPOS)
        ld   (LEND),de
       ;ld   a,$FF
       ;ld   (de),a          ;end of encoding marker
       ;inc  de
        bit  0,(ix+26)       ;1=print, 0=don't
        jr   z,SETDBEG
        bit  1,(ix+26)       ;1=text, 0=pict
        jr   nz,SETDBEG
        ld   de,16384
SETDBEG:ld   (DBEG),de       ;DE=decoded output start
        ld   hl,(IEND)
        ld   (LPOS),hl       ;HL=encoded output start
        ld   (CODADD),hl
        ld   a,(hl)          ;A =coding flag byte
        inc  hl
        ld   bc,(OBYTES)     ;BC=total encoded bytes
        dec  bc
        ld  (ix+34),8        ;(CODSEQ)=coding flag byte sequence

        ;START OF THE DECODING LOOP
S1TOLP: push bc           ;0>;BC=loop counter
        push hl           ;1>;HL=encoding pointer
        push de           ;2>;DE=decoding pointer
        ld   (PTMP),de

        ld   c,0             ;move next entry length from flag byte to C
        sla  a
        rl   c

        ld   de,BUFFER
        push af           ;3>
        ld   a,c             ;A =PLEN
        ld   (TMPBYTE),a
        or   a
        jr   z,DECODE1       ;IF PLEN=1

;2+ matches: 2 bytes : llllllll oooooooo  : length+offset
DECODE2:ld   b,0
        ld   c,(hl)          ;BC=copy length from decoded output
        inc  hl
        ld   d,b             ;B =0
        ld   e,(hl)          ;DE=match offset
        inc  hl
        push hl           ;4>
        ld   hl,(PTMP)       ;HL=decoding pointer
        sbc  hl,de           ;HL=copy point  from decoded output
        push bc           ;5>
        ld   de,BUFFER       ;DE=copy point to print buffer
        ldir
        pop  bc           ;5<
        pop  hl           ;4<
        jr   PRINTDE

; 1 match:   1 byte  : mmmmmmmm           : mchar
; 0 matches: 1 byte  : cccccccc           : cchar
DECODE1:ld   a,(hl)
        ld   (de),a
        ld   bc,1

PRINTDE:ld   de,BUFFER
        push bc           ;4>
        bit  1,(ix+26)       ;1=text, 0=pict
        jr   z,NOPRINT
        bit  0,(ix+26)       ;1=print, 0=don't
        jr   z,NOPRINT
        call PRINTS
NOPRINT:pop  bc           ;4<
        pop  af           ;3<;A =flag byte
        ld   hl,BUFFER
        pop  de           ;2<
        ldir
        pop  hl           ;1<;HL=current LPOS
        pop  bc           ;0<

        ex   af,af'
        ld   a,(TMPBYTE)
        or   a
        jr   z,ONEBYTE       ;IF PLEN=0/1
        inc  hl
        dec  bc
ONEBYTE:inc  hl
        dec  bc
        ex   af,af'
        dec  (ix+34)         ;(CODSEQ)=coding flag byte sequence
        jr   nz,COUNT0

        ld   (CODADD),hl
        ld   a,(hl)          ;A =coding flag byte
        ld   (ix+34),8       ;(CODSEQ)=coding flag byte sequence
        inc  hl
        dec  bc

COUNT0: ld   (TMPBYTE),a
        inc  bc              ;check for -1 ($ffff)
        ld   a,b
        or   c
        jr   z,ENDRUN
        dec  bc              ;check for zero
        ld   a,b
        or   c
        ld   a,(TMPBYTE)
        jp   nz,S1TOLP

        ;END OF THE DECODING LOOP
ENDRUN: pop hl               ;restore H'L'
        exx
        ret

;OUTUPD: ld   hl,(OBYTES)
;        add  hl,de           ;add DE bytes
;        ld   (OBYTES),hl
;        ld   hl,(LPOS)
;        add  hl,de           ;add DE bytes
;        ld   (LPOS),hl
;        ret

BUFFER: defs MAXSIZE         ;workspace