
; LZupack - Lempel-Ziv unpack routine
; LET bc=i=o+USR LZupack
; i=input address, o=output address
; LZupack=org+6

        org  65100

STKEND: equ  23653
FPTOBC: equ  $2da2           ;from calculator stack: BC

MCWORK: defs 6               ;start of working storage

TMPWORD:equ  MCWORK          ;temp.store
TMPBYTE:equ  MCWORK+2        ;temp.store
CODSEQ: equ  MCWORK+3        ;coding flag byte sequence: 8->1
CODADD: equ  MCWORK+4        ;coding flag byte address

;ENCODING
; Coding flag byte specifies length of next 8 entries.
; Coding entries may be:
; 0 matches: 1 byte  : cccccccc           : cchar
; 1 match:   1 byte  : mmmmmmmm           : mchar
;2+ matches: 2 bytes : llllllll oooooooo  : length+offset

        ;DECODING SETUP
SETUPD: call FPTOBC
        push bc              ;BC=decoded output start
        call FPTOBC
        ld   hl,(STKEND)
        ld   de,10
        add  hl,de
        ld   (STKEND),hl     ;restore (STKEND)

        ld   h,b
        ld   l,c
        ld   a,(hl)          ;HL=encoded file start (begins with length)
        ld   c,a
        inc  hl
        ld   a,(hl)
        ld   b,a             ;BC=encoded input length
        inc  hl              ;HL=encoded input start
        pop  de              ;DE=decoded output start

        ld   (CODADD),hl
        ld   a,(hl)          ;A =coding flag byte
        inc  hl
        dec  bc
        ld   ix,MCWORK       ;
        ld  (ix+03),8        ;(CODSEQ)=coding flag byte sequence

        ;START OF THE DECODING LOOP
S1TOLP: push bc           ;0>;BC=loop counter
        push hl           ;1>;HL=encoding pointer
        push de           ;2>;DE=decoding pointer
        ld   (TMPWORD),de

        ld   c,0             ;move next entry length from flag byte to C
        sla  a
        rl   c

        push af           ;3>
        ld   a,c             ;A =PLEN
        ld   (TMPBYTE),a
        or   a
        ld   bc,1
; 0 matches: 1 byte  : cccccccc           : cchar
; 1 match:   1 byte  : mmmmmmmm           : mchar
        jr   z,PRINTDE       ;IF PLEN=1

;2+ matches: 2 bytes : llllllll oooooooo  : length+offset
DECODE2:ld   c,(hl)          ;BC=copy length from decoded output
        inc  hl
        ld   d,b             ;B =0
        ld   e,(hl)          ;DE=match offset
        inc  hl
        ld   hl,(TMPWORD)    ;HL=decoding pointer
        sbc  hl,de           ;HL=copy point  from decoded output

PRINTDE:pop  af           ;3<;A =flag byte
        pop  de           ;2<
        ldir
        pop  hl           ;1<;HL=current LPOS
        pop  bc           ;0<

        ex   af,af'
        ld   a,(TMPBYTE)
        or   a
        jr   z,ONEBYTE       ;IF PLEN=0/1
        inc  hl
        dec  bc
ONEBYTE:inc  hl
        dec  bc
        ex   af,af'
        dec  (ix+03)         ;(CODSEQ)=coding flag byte sequence
        jr   nz,COUNT0

        ld   (CODADD),hl
        ld   a,(hl)          ;A =coding flag byte
        ld   (ix+03),8       ;(CODSEQ)=coding flag byte sequence
        inc  hl
        dec  bc

COUNT0: ld   (TMPBYTE),a
        inc  bc              ;check for -1 ($ffff)
        ld   a,b
        or   c
        jr   z,ENDRUN
        dec  bc              ;check for zero
        ld   a,b
        or   c
        ld   a,(TMPBYTE)
        jp   nz,S1TOLP

        ;END OF THE DECODING LOOP
ENDRUN: ret